`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/04/01 19:35:26
// Design Name: 
// Module Name: BCD_up_4d
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
`define ENABLE 1'b1
`define DISABLE 1'b0
module BCD_up_4d(
    digit_3,
    digit_2,
    digit_1,
    digit_0,
    rst_n,
    clk,
    AM_PM_convert,
    en
    );
    output [3:0] digit_0, digit_1, digit_2, digit_3; //digit_0, digit_1 for minutes, digit_2, digit_3 for hours 
    output reg AM_PM_convert;
    input clk, rst_n, en;

    reg rst_hour;
    
    wire c0, c1, c2, c3;
   
    always @* 
    begin
        case ({digit_3, digit_2})
          8'b0001_0010:
                AM_PM_convert = 1'b1;
          8'b0001_0011:
                AM_PM_convert = 1'b1;
          8'b0001_0100:
                AM_PM_convert = 1'b1;
          8'b0001_0101:
                AM_PM_convert = 1'b1;
          8'b0001_0110: 
                AM_PM_convert = 1'b1;
          8'b0001_0111:
                AM_PM_convert = 1'b1;
          8'b0001_1000:
                AM_PM_convert = 1'b1;
          8'b0001_1001:
                AM_PM_convert = 1'b1;
          8'b0010_0000:
                AM_PM_convert = 1'b1;
          8'b0010_0001:
                AM_PM_convert = 1'b1;
          8'b0010_0010:
                AM_PM_convert = 1'b1;
          8'b0010_0011:
                AM_PM_convert = 1'b1;
          default: 
                AM_PM_convert = 1'b0;
        endcase
    end

    always @*
    begin
      if (digit_3 == 4'd2 && digit_2 == 4'd3) 
        rst_hour = 1'b1;
      else
        rst_hour = 1'b0;
    end


    BCD_up U0(
    .value(digit_0), 
    .carry_out(c0), 
    .clk(clk), 
    .rst_n(rst_n), 
    .increase(en),
    .init_value(4'd0), 
    .limit(4'd9),
    .rst_hour(`DISABLE)
    );
    
    BCD_up U1(
    .value(digit_1), 
    .carry_out(c1), 
    .clk(clk), 
    .rst_n(rst_n), 
    .increase(c0),
    .init_value(4'd5), 
    .limit(4'd5),
    .rst_hour(`DISABLE)
    );

    BCD_up U2(
    .value(digit_2), 
    .carry_out(c2), 
    .clk(clk), 
    .rst_n(rst_n), 
    .increase(c1),
    .init_value(4'd2), 
    .limit(4'd9),
    .rst_hour(rst_hour)
    );

    BCD_up U3(
    .value(digit_3), 
    .carry_out(c3), 
    .clk(clk), 
    .rst_n(rst_n), 
    .increase(c2),
    .init_value(4'd1), 
    .limit(4'd2),
    .rst_hour(rst_hour)
    );
endmodule




